// Code generated by mockery v2.53.0. DO NOT EDIT.

package db

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	models "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/models"
)

// MockPlugins is an autogenerated mock type for the Plugins type
type MockPlugins struct {
	mock.Mock
}

// CreatePlugin provides a mock function with given fields: ctx, plugin
func (_m *MockPlugins) CreatePlugin(ctx context.Context, plugin *models.Plugin) (*models.Plugin, error) {
	ret := _m.Called(ctx, plugin)

	if len(ret) == 0 {
		panic("no return value specified for CreatePlugin")
	}

	var r0 *models.Plugin
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.Plugin) (*models.Plugin, error)); ok {
		return rf(ctx, plugin)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.Plugin) *models.Plugin); ok {
		r0 = rf(ctx, plugin)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Plugin)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.Plugin) error); ok {
		r1 = rf(ctx, plugin)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeletePlugin provides a mock function with given fields: ctx, plugin
func (_m *MockPlugins) DeletePlugin(ctx context.Context, plugin *models.Plugin) error {
	ret := _m.Called(ctx, plugin)

	if len(ret) == 0 {
		panic("no return value specified for DeletePlugin")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.Plugin) error); ok {
		r0 = rf(ctx, plugin)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetPluginByID provides a mock function with given fields: ctx, id
func (_m *MockPlugins) GetPluginByID(ctx context.Context, id string) (*models.Plugin, error) {
	ret := _m.Called(ctx, id)

	if len(ret) == 0 {
		panic("no return value specified for GetPluginByID")
	}

	var r0 *models.Plugin
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.Plugin, error)); ok {
		return rf(ctx, id)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.Plugin); ok {
		r0 = rf(ctx, id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Plugin)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetPluginByPRN provides a mock function with given fields: ctx, prn
func (_m *MockPlugins) GetPluginByPRN(ctx context.Context, prn string) (*models.Plugin, error) {
	ret := _m.Called(ctx, prn)

	if len(ret) == 0 {
		panic("no return value specified for GetPluginByPRN")
	}

	var r0 *models.Plugin
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.Plugin, error)); ok {
		return rf(ctx, prn)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.Plugin); ok {
		r0 = rf(ctx, prn)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Plugin)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, prn)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetPlugins provides a mock function with given fields: ctx, input
func (_m *MockPlugins) GetPlugins(ctx context.Context, input *GetPluginsInput) (*PluginsResult, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for GetPlugins")
	}

	var r0 *PluginsResult
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *GetPluginsInput) (*PluginsResult, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *GetPluginsInput) *PluginsResult); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*PluginsResult)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *GetPluginsInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdatePlugin provides a mock function with given fields: ctx, plugin
func (_m *MockPlugins) UpdatePlugin(ctx context.Context, plugin *models.Plugin) (*models.Plugin, error) {
	ret := _m.Called(ctx, plugin)

	if len(ret) == 0 {
		panic("no return value specified for UpdatePlugin")
	}

	var r0 *models.Plugin
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.Plugin) (*models.Plugin, error)); ok {
		return rf(ctx, plugin)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.Plugin) *models.Plugin); ok {
		r0 = rf(ctx, plugin)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Plugin)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.Plugin) error); ok {
		r1 = rf(ctx, plugin)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// NewMockPlugins creates a new instance of MockPlugins. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockPlugins(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockPlugins {
	mock := &MockPlugins{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
